<?php

namespace AMZcockpitDoctrine\Repository;

use AMZcockpitDoctrine\Entity\User;

/**
 * NotificationRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class NotificationRepository extends \Doctrine\ORM\EntityRepository
{
    public function getLastNotification(User $user)
    {
        /** @var \Doctrine\ORM\QueryBuilder $qb */
        $qb = $this->createQueryBuilder('n');
        $qb->select('n')
            ->andWhere($qb->expr()->eq(':statut', 'n.statut'))
            ->andWhere($qb->expr()->isMemberOf(':user', 'n.users'))
            ->andWhere(':user NOT MEMBER OF n.usersSeen')
            ->andWhere('n.createdAt > :createdAt')
            ->setParameter('statut', \AMZcockpitDoctrine\DBAL\Types\AudienceStatutType::SAVED)
            ->setParameter('createdAt', $user->getCreatedAt())
            ->setParameter('user', $user);

        $qb->orderBy('n.createdAt','ASC');
        $qb->setFirstResult(0);
        $qb->setMaxResults(1);

        return $qb->getQuery()->getOneOrNullResult();
    }
}
